{
 CISLO: 25

 Program dokaze nacist mapu, nacist reseni, ulozit reseni a nekdy i najit reseni.
 
 Reseni se hleda pomoci velmi jednoducheho algoritmu, ktery se snazi jit po
 _jednom_ policku do cile (tedy rychlost je vzdu -1, 0, nebo 1, pricemz jde po
 doporucene ceste (tedy po ':'), po '.' jde pouze v pripade, ze zadnou dvojtecku
 nenajde. Bohuzel tento algoritmus neni vzdy funkcni a funguje pouze na nekterych
 vstupech :(
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, StdCtrls;

type
  XY = record { struktura obsahujici souradnice }
        x : integer;
        y : integer;
       end;

  AXY = array[1..10000] of XY; { pole souradnic }

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Otevt1: TMenuItem;
    Uloiteen1: TMenuItem;
    Konec1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Image1: TImage;
    Button1: TButton;
    ListBox1: TListBox;
    Otevteen1: TMenuItem;
    procedure add(var x, y, a, b, cx, cy : integer);
    procedure openmap(filename : string);
    procedure drawmap;
    procedure drawsolution(var pole : AXY; n : integer);
    procedure Konec1Click(Sender: TObject);
    procedure Otevt1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Otevteen1Click(Sender: TObject);
    procedure Uloiteen1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  data : array[1..255, 1..255] of char; { mapa }
  pdata : array[1..255, 1..255] of byte; { znaci, zda jsme jiz toto navstivili }
  maxx, maxy : integer; { rozmery mapy }
  start : XY; { pocatecni policko }
  sol : AXY;  { seznam vrcholu reseni }
  n_sol : integer;
  stepx, stepy : integer; { velikost jednoho policka }

implementation

{$R *.dfm}

{ vykresli reseni }

procedure TForm1.drawsolution(var pole : AXY; n : integer);
var cx, cy : integer;
    sx, sy : integer;
    x, y : integer;
    i : integer;
begin
        sx := 0;
        sy := 0;

        x := start.x;
        y := start.y;

        image1.canvas.Brush.Color := 65280;
        image1.canvas.Pen.Color := 65280;

        image1.canvas.Ellipse((x - 1) * stepx, (y - 1) * stepy, x * stepx, y * stepy);

        for i := 1 to n do
        begin
                cx := pole[i].x;
                cy := pole[i].y;

                sx := sx + cx;
                sy := sy - cy;

                if data[x + sx, y + sy] = 'X' then
                begin
                        sx := 0;
                        sy := 0;
                end
                else
                begin
                        x := x + sx;
                        y := y + sy;
                end;

                image1.canvas.Ellipse((x - 1) * stepx, (y - 1) * stepy, x * stepx, y * stepy);
                image1.canvas.moveto(round((x - sx - 0.5) * stepx), round((y - sy - 0.5) * stepy));
                image1.Canvas.lineto(round((x - 0.5) * stepx), round((y - 0.5) * stepy));
        end;
end;

{ procedura nakresli mapu }

procedure TForm1.drawmap;
var x, y : integer;
begin
        stepx := image1.Width div maxx; { sirka a vyska jednoho policka }
        stepy := image1.Height div maxy;

        for y := 1 to maxy do
                for x := 1 to maxx do
                begin
                        case data[x,y] of { co je to za policko? }
                        'X': begin
                                image1.Canvas.Brush.Color := 0;
                             end;
                        '.': begin
                                image1.Canvas.Brush.Color := 16777215;
                             end;
                        ':': begin
                                image1.Canvas.Brush.Color := 8388607;
                             end;
                        'S': begin
                                image1.Canvas.Brush.Color := 255;

                                start.x := x;
                                start.y := y;
                             end;
                        'C': begin
                                image1.Canvas.Brush.Color := 16711680;
                             end;
                        end;

                        image1.canvas.Rectangle((x - 1) * stepx, (y - 1) * stepy, x * stepx, y * stepy);
                end;
end;

{ Procedura otevre a nacte mapu }

procedure TForm1.openmap(filename : string);
var f : TextFile;
    xs : integer;
    ch : char;
begin
        assignfile(f, filename);
        reset(f);

        if IOResult <> 0 then exit; 

        maxx := 0;

        while not eoln(f) do { nejprve si zjistime delku prvniho radku }
        begin
                maxx := maxx + 1;

                read(f, data[maxx, 1]);

                ch := data[maxx, 1];
        end;

        maxy := 1;

        while not eof(f) do
        begin
                read(f, ch); { nacteni znaku konce radky }
                read(f, ch);

                maxy := maxy + 1;

                xs := 0;

                while not eoln(f) do
                begin
                        xs := xs + 1;

                        read(f, data[xs, maxy]);

                        ch := data[xs, maxy];
                end;
        end;
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
        halt;
end;

procedure TForm1.Otevt1Click(Sender: TObject);
begin
        if OpenDialog1.execute = true then
        begin
                openmap(opendialog1.FileName);

                drawmap;
        end;
end;

{ procedura zkusi pridat dalsi vrchol do reseni }

procedure TForm1.add(var x, y, a, b, cx, cy : integer);
begin
        if cx < a then
                cx := cx + 1;

        if cy < b then
                cy := cy + 1;

        if cx > a then
                cx := cx - 1;

        if cy > b then
                cy := cy - 1;

        n_sol := n_sol + 1;

        if data[x + cx, y + cy] = 'X' then
        begin
                cx := 0;
                cy := 0;
        end;

        sol[n_sol].x := cx;
        sol[n_sol].y := - cy;

        x := x + cx;
        y := y + cy;

        pdata[x,y] := 1;

        image1.canvas.Brush.Color := 65280;
        image1.canvas.Pen.Color := 65280;

        image1.canvas.Ellipse((x - 1) * stepx, (y - 1) * stepy, x * stepx, y * stepy);
        image1.canvas.moveto(round((x - cx - 0.5) * stepx), round((y - cy - 0.5) * stepy));
        image1.Canvas.lineto(round((x - 0.5) * stepx), round((y - 0.5) * stepy));

        listbox1.AddItem(inttostr(cx) + ', ' + inttostr(cy) + '    [' + inttostr(x + cx) + ', ' + inttostr(maxy - y - cy) + ']', nil);
end;

{ Hledej reseni }

procedure TForm1.Button1Click(Sender: TObject);
var x, y : integer;
    cx, cy : integer;
    a, b : integer;

    found, nevadi : boolean;

    i, j : integer;
begin
        for i := 1 to 255 do
                for j := 1 to 255 do
                        pdata[i, j] := 0;

        x := start.x;
        y := start.y;
        cx := 0;
        cy := 0;

        n_sol := 0;

        nevadi := false;

        while data[x,y] <> 'C' do
        begin
                found := false;

                for a := -1 to 1 do { zkusime mozne prirustky }
                        for b := -1 to 1 do
                        begin
                                if ((data[x + a, y + b] = 'C') or (data[x + a, y + b] = ':'))
                                        and ((pdata[x + a, y + b] <> 1) or (nevadi = true)) then
                                begin

                                        found := true;
                                        nevadi := false;

                                        add(x, y, a, b, cx, cy);
                                end;
                        end;
               if found = false then { nic jsme nenasli zkusime i policka '.' }
               begin
                        for a := -1 to 1 do
                                for b := -1 to 1 do
                                begin
                                        if (data[x + a, y + b] = '.') and
                                                ((pdata[x + a, y + b] <> 1) or (nevadi = true)) then

                                        begin
                                                add(x, y, a, b, cx, cy);

                                                found := true;
                                                nevadi := false;
                                        end;
                                end;
               end;

               if found = false then
                        nevadi := true;

        end;

        {drawsolution(pole, n);}
end;

{ Procedura otevre soubor s resenim a vykresli ho. Pro spravne fungovani ale
  soubor nesmi obsahovat carky (neumim to obejit). }

procedure TForm1.Otevteen1Click(Sender: TObject);
var f : textfile;
    ch : char;
    pole : AXY;
    n : integer;
begin
        if OpenDialog1.Execute then
        begin
                assignfile(f, OpenDialog1.FileName);

                reset(f);

                n := 0;

                while not eof(f) do
                begin
                        n:= n + 1;

                        read(f, pole[n].x);
                        read(f, pole[n].y);
                end;
        
                drawsolution(pole, n);

                closefile(f);
        end;
end;

{ Ulozeni reseni }

procedure TForm1.Uloiteen1Click(Sender: TObject);
var f : TextFile;
    i : integer;
begin
        if SaveDialog1.Execute = true then
        begin
                assignfile(f, savedialog1.filename);

                rewrite(f);

                for i := 1 to n_sol do
                begin
                        writeln(f, sol[i].x, ', ', sol[i].y);
                end;

                closefile(f);
        end;
end;

end.
